/*============================================================================
  Summary:  Demonstrates Dead Locking because of a Missing Index
------------------------------------------------------------------------------
  Written by Klaus Aschenbrenner, www.SQLpassion.at

  For more scripts and sample code, check out 
    http://www.SQLpassion.at

  THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF 
  ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED 
  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
  PARTICULAR PURPOSE.
============================================================================*/

-- =========
-- Session 2
-- =========

-- Use the previous created database
USE DeadlockingDemo
GO

BEGIN TRANSACTION

	-- Acquires an Exclusive Lock on the row
	UPDATE Table2 SET Column1 = 5 WHERE Column2 = 2

	SELECT * FROM sys.dm_tran_locks
	WHERE request_session_id = @@SPID

	-- Continue with the query from Session 2...
	-- ...

	-- This query now requests a Shared Lock, but get's blocked, because the other session/transaction has an Exclusive Lock on one row, that is currently updated
	SELECT Column1 FROM Table1
	--WITH (INDEX = idx_Column2) -- The index hint is necessary, because in this tiny table, SQL Server will just scan the whole table...
	WHERE Column2 = 4

ROLLBACK TRANSACTION
GO